(function (global) {
    "use strict";

    global.ND = global.ND || {};
    global.ND.Portal = global.ND.Portal || {};
    global.ND.Portal.LeaseAgreementDetails = (function() {
        
        
		var _currentAdditionalLesseesPage = 1;
		var _currentLeaseProvisionsPage = 1;
        var handleSurfaceFormOnLoad = async function (event) {
            _commmonOnLoad();
            
            ND.Portal.Tables.renderSubgrid('additionalLesseesSection', 'Additional Lessees');
            ND.Portal.Tables.renderSubgrid('leaseProvisionsSection', 'Lease Provisions');
            
			ND.Portal.Tables.handlePageToggle(1, _currentAdditionalLesseesPage, "additionalLessees", _createAdditionalLesseesRow, "ND Service: Get Additional Lessee By Lease Agreement");
			ND.Portal.Tables.handlePageToggle(1, _currentLeaseProvisionsPage, "leaseProvisions", _createLeaseProvisionsRow, "ND Service: Get Lease Provisions By Lease Agreement");

            var isMy = $('main').attr('data-ismy');
            if (isMy !== 'true') {
                $('#ndland_paymentstatus').parents('td').remove();
            }
            else {
                if (!$('#ndland_paymentstatus').val()) {
                    $('#ndland_paymentstatus').find('[label="Select"]').attr('label', '')
                }
            }
            
            if (!$('#ndland_terminationdate').val()) {
                moveField('eyland_term', 'ndland_annualrent');
                moveField('ndland_extensiondate', 'eyland_leasedacres');
                moveField('ndland_numofextensions', 'ndland_paymentstatus');
            }
        }

		var _createAdditionalLesseesRow =  (result) => {
			return `
				<tr>
					<td data-th="Name" >
						${result.Lessee}
					</td>
				</tr>`;
		};

		var _createLeaseProvisionsRow =  (result) => {
			return `
				<tr>
					<td data-th="Type" >
						${result.Type}
					</td>
				</tr>`;
		};
        
        var handleSurfaceMineralFormOnLoad = async function (event) {
            _commmonOnLoad();

            var isMy = $('main').attr('data-ismy');
            if (isMy !== 'true') {
                $('#ndland_reclamationsuretybondamount').parents('td').remove();
                $('#ndland_reclamationplanapproveddate').parents('td').remove();
                $('#ndland_releaseofsuretybond').parents('td').remove();
            };
            
            if (!$('#ndland_terminationdate').val()) {
                moveField('eyland_term', 'ndland_surfacemineraltypeid');
            }
        }

        var currentOwnershipsPage = 1;
        var handleOGFormOnLoad = async function (event) {
            _commmonOnLoad();

            if (!$('#ndland_shutinstartdate').val()) {
                $('fieldset[aria-label="Shut In"]').remove();
            }

            ND.Portal.Forms.removeFieldIfBlank('ndland_applicationid');
            
            var isMy = $('main').attr('data-ismy');
            if (isMy !== 'true' || !$('#ndland_nominationapplicationid').val()) {
                $('#ndland_nominationapplicationid').parents('td').remove();
            }
            
            var status = $('#status').text();
            if (status === 'Inactive' || status.includes('Terminated')) {
                $('fieldset[aria-label="Ownership"]').remove();
            }
            else {
                ND.Portal.Tables.renderSubgrid('ownershipOGSection', 'Ownership');
                _handleOwnershipOGPageToggle(1)
            }
            
            if (!$('#ndland_terminationdate').val()) {
                moveField('eyland_term', 'ndland_mineralleasedacres');
            }
        }

		var _handleOwnershipOGPageToggle = function(selectedPage) {
			const urlParams = new URLSearchParams(window.location.search);
			const id = urlParams.get('id');
			
			var requestUrl = `/Services?name=ND Service: Get Lease Agreement Ownership by Lease Agreement&page={0}&id=${id}`;
			const tableSettings = AgreementConfigurations["ownershipOG"];
			const orderOn = tableSettings?.OrderingConfiguration?.OrderOn;
			if (orderOn) {
				const orderBy = tableSettings?.OrderingConfiguration?.OrderBy || "ascending";
				requestUrl += `&orderOn=${orderOn}&orderBy=${orderBy}`;
			}
			currentOwnershipsPage = ND.Portal.Tables.handleTablePaging(currentOwnershipsPage,
				selectedPage,
				requestUrl,
				"ownershipOG",
				_createOwnershipOGRow,
				_handleOwnershipOGPageToggle, AgreementConfigurations);
		}
        
		var _createOwnershipOGRow =  (result) => {
            var percent = result.PercentOwnership * 100;
			return `
				<tr>
					<td data-th="Assignee" >
						${result.Assignee}
					</td>
					<td data-th="% Ownership" >
						${percent.toFixed(6)}%
					</td>
					<td data-th="% Ownership" >
						${result.Stratigraphic}
					</td>
				</tr>`;
		};

        var handleCoalFormOnLoad = async function (event) {
            _commmonOnLoad();
            
            var isMy = $('main').attr('data-ismy');
            if (isMy !== 'true' || !$('#ndland_nominationapplicationid').val()) {
                $('#ndland_nominationapplicationid').parents('td').remove();
            }
            
            var status = $('#status').text();
            if (status === 'Inactive' || status.includes('Terminated')) {
                $('fieldset[aria-label="Ownership"]').remove();
            }
            else {
                ND.Portal.Tables.renderSubgrid('ownershipCoalSection', 'Ownership');
                _handleOwnershipCoalPageToggle(1);
            }

            if (!$('#ndland_terminationdate').val()) {
                moveField('eyland_term', 'ndland_mineralleasedacres');
            }
        }
        
		var _handleOwnershipCoalPageToggle = function(selectedPage) {
			const urlParams = new URLSearchParams(window.location.search);
			const id = urlParams.get('id');
			
			var requestUrl = `/Services?name=ND Service: Get Lease Agreement Ownership by Lease Agreement&page={0}&id=${id}`;
			const tableSettings = AgreementConfigurations["ownershipCoal"];
			const orderOn = tableSettings?.OrderingConfiguration?.OrderOn;
			if (orderOn) {
				const orderBy = tableSettings?.OrderingConfiguration?.OrderBy || "ascending";
				requestUrl += `&orderOn=${orderOn}&orderBy=${orderBy}`;
			}
			currentOwnershipsPage = ND.Portal.Tables.handleTablePaging(currentOwnershipsPage,
				selectedPage,
				requestUrl,
				"ownershipCoal",
				_createOwnershipCoalRow,
				_handleOwnershipCoalPageToggle, AgreementConfigurations);
		}

		var _createOwnershipCoalRow =  (result) => {
            var percent = result.PercentOwnership * 100;
			return `
				<tr>
					<td data-th="Assignee" >
						${result.Assignee}
					</td>
					<td data-th="% Ownership" >
						${percent.toFixed(6)}%
					</td>
				</tr>`;
		};

        var _commmonOnLoad = () => {
            $("#AttachFile").parent().parent().hide();
            $('.tab-title').hide();
            $(".info").removeClass("required");
            handleTabMobileClick();
            
            ND.Portal.Forms.removeFieldIfBlank('ndland_terminationdate');
            ND.Portal.Forms.removeFieldIfBlank('ndland_extensiondate');
            ND.Portal.Forms.removeFieldIfBlank('ndland_numofextensions');
            
            var isMy = $('main').attr('data-ismy');
            if (isMy === 'true') {
                ND.Portal.Tables.renderSubgrid('paymentHistorySection', 'Payment History');
                _handlePaymentPageToggle(1);

            }
            
            ND.Portal.Tables.renderSubgrid('documentsSection', 'Documents');
            _handleDocumentPageToggle(1);
        }
        
		var handleTabMobileClick = () => {
			$('#tab_selector').on('change', function (e) {
				$('.form-tabs li a').eq($(this).val()).tab('show');
			});
		}

		var currentPaymentHistoryPage = 1;
		var _handlePaymentPageToggle = function(selectedPage) {
			const urlParams = new URLSearchParams(window.location.search);
			const id = urlParams.get('id');
			
			var requestUrl = `/Services?name=ND Service: Get Payment History By Lease Agreement&page={0}&id=${id}`;
			const tableSettings = AgreementConfigurations["paymentHistory"];
			const orderOn = tableSettings?.OrderingConfiguration?.OrderOn;
			if (orderOn) {
				const orderBy = tableSettings?.OrderingConfiguration?.OrderBy || "ascending";
				requestUrl += `&orderOn=${orderOn}&orderBy=${orderBy}`;
			}
			currentPaymentHistoryPage = ND.Portal.Tables.handleTablePaging(currentPaymentHistoryPage,
				selectedPage,
				requestUrl,
				"paymentHistory",
				_createPaymentHistoryRow,
				_handlePaymentPageToggle, AgreementConfigurations);
		}
        
		const documentBodies = {};
		var currentDocumentsPage = 1;
		var _handleDocumentPageToggle = function(selectedPage) {
			const urlParams = new URLSearchParams(window.location.search);
			const agreementId = urlParams.get('id');
			if (agreementId) {
				ND.Portal.Documents.loadDocumentTable(fileNetBaseUrl, "eyland_leaseagreement", _createDocumentsRow);
			}
		}
        
		var _createPaymentHistoryRow = (result) => {
			return `
				<tr>
					<td data-th="Payment Date">${result.PaymentDate}</td>
					<td data-th="Payor">${result.Payor}</td>
					<td data-th="Invoice #">${result.InvoiceNumber}</td>
					<td data-th="Amount Paid">${result.AmountPaid}</td>
				</tr>`;
		}

		var _createDocumentsRow = (result) => {
            documentBodies[result.DocumentId] = result.DocumentBody;

			$("#document-count").show();
            $("#document-count-value").text(result.TotalRecordCount);

			return `
				<tr>
					<td class='title' data-th="File Name">
                        <button type="button" class="btn btn-link-inline underline" onclick="ND.Portal.Documents.downloadPortalDocument('${result.DocumentId}', '${result.DocumentTitle}')">
                            <span class="text">${result.FileName}</span>
                        </button>
                    </td>
					<td data-th="Subject">${result.Subject}</td>
					<td data-th="Type">${result.Type}</td>
					<td data-th="Date Uploaded">${result.DateUploaded}</td>
				</tr>`;
		}
        
        const AgreementConfigurations = {
            "ownershipOG": {
                PagingCallback: _handleOwnershipOGPageToggle,
                GetCurrentPage: () => { return currentOwnershipsPage; },
                OrderingConfiguration: {
                    OrderOn: "ndland_customerid",
                    OrderBy: "ascending"
                },
                InvertedSorting: [
                    'ndland_percentownership'
                ]
            },
            "ownershipCoal": {
                PagingCallback: _handleOwnershipCoalPageToggle,
                GetCurrentPage: () => { return currentOwnershipsPage; },
                OrderingConfiguration: {
                    OrderOn: "ndland_customerid",
                    OrderBy: "ascending"
                },
                InvertedSorting: [
                    'ndland_percentownership'
                ]
            },
            "paymentHistory": {
                PagingCallback: _handlePaymentPageToggle,
                GetCurrentPage: () => { return currentPaymentHistoryPage; },
                OrderingConfiguration: {
                    OrderOn: "ndland_paymentdate",
                    OrderBy: "descending",
                    Inverted: true
                },
                InvertedSorting: [
                    'ndland_paymentdate',
                    'ac.ndland_amountpaid'
                ]
            },
            "documents": {
                PagingCallback: _handleDocumentPageToggle,
                GetCurrentPage: () => { return currentDocumentsPage; },
                OrderingConfiguration: {
                    OrderOn: "createdon",
                    OrderBy: "descending",
                    Inverted: true
                },
                InvertedSorting: [
                    'createdon'
                ]
            }
        };

        var moveField = (field, nextTo) => {
            $(`#${nextTo}`).closest('td').after($(`#${field}`).closest('td'))
        }

        return {
            handleSurfaceFormOnLoad: handleSurfaceFormOnLoad,
            handleSurfaceMineralFormOnLoad: handleSurfaceMineralFormOnLoad,
            handleOGFormOnLoad: handleOGFormOnLoad,
            handleCoalFormOnLoad: handleCoalFormOnLoad,
            AgreementConfigurations: AgreementConfigurations
        }
    })();

})(this);